local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Livestock2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/MilkCart2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Building Part Type -------------------------------------------------------------------------------------
mod:registerEnumValue("BUILDING_PART_TYPE", "PASTURE")
mod:registerEnumValue("ATTACH_NODE_TYPE", "PASTURE")



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattleYard.Part.001", "PREFAB_LIVESTOCKFARM_CATTLEYARD1")
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattleYard.Part.002", "PREFAB_LIVESTOCKFARM_CATTLEYARD2")
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattleYard.Part.003", "PREFAB_LIVESTOCKFARM_CATTLEYARD3")
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattleYard.Part.004", "PREFAB_LIVESTOCKFARM_CATTLEYARD4")

mod:registerAssetId("models/Livestock2.fbx/Prefab/CattlePen.Part.001", "PREFAB_LIVESTOCKFARM_CATTLEPEN1")
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattlePen.Part.002", "PREFAB_LIVESTOCKFARM_CATTLEPEN2")
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattlePen.Part.003", "PREFAB_LIVESTOCKFARM_CATTLEPEN3")
mod:registerAssetId("models/Livestock2.fbx/Prefab/CattlePen.Part.004", "PREFAB_LIVESTOCKFARM_CATTLEPEN4")

mod:registerAssetId("models/textures/Blank.png", "TEXTURE_LIVESTOCKFARM_BLANK")

mod:registerAssetId("models/Livestock2.fbx/Prefab/CattlePasture.Part.001", "PREFAB_LIVESTOCKFARM_CATTLEPASTURE1")

mod:registerAssetId("models/MilkCart2.fbx/Prefab/CartPart", "PREFAB_LIVESTOCKFARM_MILKCART")


-- mod:registerAssetId("models/Livestock2.fbx/Prefab/CowDecorative", "PREFAB_LIVESTOCKFARM_COWDECORATIVE")

for i=1, 5, 1 do
    mod:registerAssetId("models/Livestock2.fbx/Prefab/Pasture.Part." .. string.sub("000" .. i, -3), "PREFAB_LIVESTOCKFARM_PASTUREPLANT" .. i)
    mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/Pasture.Part." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })
end



-- Transparency -------------------------------------------------------------------------------------
mod:registerAssetId("models/Livestock2.fbx/Materials/Material.Hay3", "MATERIAL_LIVESTOCKFARM_HAY3")
mod:override({
    Id = "MATERIAL_LIVESTOCKFARM_HAY3",
    HasAlphaTest = true
})

mod:registerAssetId("models/Livestock2.fbx/Materials/Material.Grass1", "MATERIAL_LIVESTOCKFARM_GRASS1")
mod:override({
    Id = "MATERIAL_LIVESTOCKFARM_GRASS1",
    HasAlphaTest = true
})

mod:registerAssetId("models/Livestock2.fbx/Materials/Material.Flowers1", "MATERIAL_LIVESTOCKFARM_FLOWERS1")
mod:override({
    Id = "MATERIAL_LIVESTOCKFARM_FLOWERS1",
    HasAlphaTest = true
})



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/Hay.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/Hay.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/Shed.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/Shed.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/Trough.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/DungHeap.001", {DataType = "COMP_GROUNDED"})
for i=1, 18, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.001/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Hay.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Hay.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Hay.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Shed.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Shed.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Trough.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/DungHeap.002", {DataType = "COMP_GROUNDED"})
for i=51, 68, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.002/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Hay.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Hay.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Hay.008", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Shed.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Shed.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Trough.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/DungHeap.003", {DataType = "COMP_GROUNDED"})
for i=69, 86, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.003/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/Hay.010", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/Shed.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/Shed.008", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/Trough.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/Trough.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/DungHeap.004", {DataType = "COMP_GROUNDED"})
for i=87, 104, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattleYard.Part.004/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.001/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.001/Bucket.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.001/Bucket.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.001/Hook.001", {DataType = "COMP_GROUNDED"})
for i=19, 26, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.001/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.002/Bucket.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.002/Bucket.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.002/Bucket.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.002/Hook.002", {DataType = "COMP_GROUNDED"})
for i=27, 34, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.002/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.003/Bucket.008", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.003/Bench.003", {DataType = "COMP_GROUNDED"})
for i=35, 42, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.003/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.004/Bucket.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.004/Bench.004", {DataType = "COMP_GROUNDED"})
for i=43, 50, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.004/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 120, 1 do
	mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePasture.Part.001/Attach_Minor." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Building part type -------------------------------------------------------------------------------------
-- mod:registerEnumValue("BUILDING_PART_TYPE", "BUILDING_PART_TYPE_LIVESTOCK")
-- mod:registerEnumValue("ATTACH_NODE_TYPE", "BUILDING_PART_TYPE_LIVESTOCK")

-- mod:registerPrefabComponent("PREFAB_LIVESTOCK_COW", {
-- 	DataType = "COMP_BUILDING_PART",
-- 	BuildingPartType = "BUILDING_PART_TYPE_LIVESTOCK"
-- })

-- mod:registerPrefabComponent("PREFAB_LIVESTOCK_COW", {
--     DataType = "COMP_BUILDING_ATTACH_NODE", 
--     AttachNodeTypeList = { "BUILDING_PART_TYPE_LIVESTOCK" },
-- })

-- mod:registerEnumValue("BUILDING_PART_TYPE", "PASTURE")
-- mod:registerEnumValue("BUILDING_PART_TYPE", "PEN")
-- mod:registerEnumValue("BUILDING_PART_TYPE", "FENCE")

-- mod:registerPrefabComponent("models/Fence2.fbx/Prefab/FencePart", { DataType = "COMP_BUILDING_PART", BuildingPartType = "DOOR" })



-- Collider Platform (climbable mesh) -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/Roman1.fbx/", { "PLATFORM" })



-- Resource Generator -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.001/TallowGenerator.001", { DataType = "COMP_LIVESTOCKFARM_RESOURCEGENERATOR", ResourceGenerator = "BUILDING_FUNCTION_LIVESTOCKFARM_TALLOW", })
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePen.Part.002/TallowGenerator.002", { DataType = "COMP_LIVESTOCKFARM_RESOURCEGENERATOR", ResourceGenerator = "BUILDING_FUNCTION_LIVESTOCKFARM_TALLOW", })




-- Paths: Milk cart -------------------------------------------------------------------------------------
mod:registerAssetId("models/MilkCart2.fbx/Prefab/CartPart/PATH_A_1", "PATH_MILKCART_A1")
mod:registerAssetId("models/MilkCart2.fbx/Prefab/CartPart/PATH_B_1", "PATH_MILKCART_B1")
mod:registerAssetId("models/MilkCart2.fbx/Prefab/CartPart/PATH_C_1", "PATH_MILKCART_C1")
mod:registerAssetId("models/MilkCart2.fbx/Prefab/CartPart/PATH_D_1", "PATH_MILKCART_D1")

mod:registerPrefabComponent("models/MilkCart2.fbx/Prefab/CartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MILKCART_B1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MILKCART_A1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MILKCART_C1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MILKCART_D1" }
        },
    }
})



-- Building Part: Cattle Yard -------------------------------------------------------------------------------------
local poly1a = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -4.00, -4.00 },
	{ -4.00, 4.00 },
	{ 4.00, 4.00 },
	{ 4.00, -4.00 },
	{ -4.00, -4.00 },
	{ -4.5, -7.0 },
	{ 4.5, -7.0 },
	{ 4.5, 4.5 },
	{ -4.5, 4.5 },
	{ -4.5, -7.0 },
}

local poly1b = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -2.50, -2.50 },
	{ -2.50, 2.50 },
	{ 2.50, 2.50 },
	{ 2.50, -2.50 },
	{ -2.50, -2.50 },
	{ -3.00, -3.00 },
	{ 3.00, -3.00 },
	{ 3.00, 3.00 },
	{ -3.00, 3.00 },
	{ -3.00, -3.00 },
}

local poly1c = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ 4.5, -7.0 },
	{ 4.5, 4.5 },
	{ -4.5, 4.5 },
	{ -4.5, -7.0 },
}

for i=1, 4, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEYARD" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEYARD" .. i .. "_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_CATTLEYARD" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0.5, 4.4, -10 },
                OrientationOffset = -15.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEYARD",
	Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEYARD_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_CATTLEYARD1",
			"BUILDING_PART_LIVESTOCKFARM_CATTLEYARD2",
			"BUILDING_PART_LIVESTOCKFARM_CATTLEYARD3",
			"BUILDING_PART_LIVESTOCKFARM_CATTLEYARD4",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0.5, 4.4, -10 },
            OrientationOffset = -15.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly1a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = poly1b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = polygon.createRectangle( {10, 4}, {0.0, -5.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
            { 
                Polygon = polygon.createRectangle( {10, 10}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEYARD",
    Cost = {
        BuildRightTaxes = { { Resource = "GOLD_COINS", Quantity = 5 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 20 },
            { Resource = "PLANK", Quantity = 10 },
        }
    },
    DesirabilityModifiers = { {
        Desirability = "DESIRABILITY_RESIDENTIAL",
        Type = "SUBSTRACT",
        Radius = 20.0,
        Value = 0.5
    } },
})



-- Building Part: Cattle Pen -------------------------------------------------------------------------------------
local poly2a = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -2.00, -2.00 },
	{ -2.00, 2.00 },
	{ 2.00, 2.00 },
	{ 2.00, -2.00 },
	{ -2.00, -2.00 },
	{ -2.20, -2.20 },
	{ 2.20, -2.20 },
	{ 2.20, 2.20 },
	{ -2.20, 2.20 },
	{ -2.20, -2.20 },
}

local poly2b = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -1.00, -1.00 },
	{ -1.00, 1.00 },
	{ 1.00, 1.00 },
	{ 1.00, -1.00 },
	{ -1.00, -1.00 },
	{ -1.50, -1.50 },
	{ 1.50, -1.50 },
	{ 1.50, 1.50 },
	{ -1.50, 1.50 },
	{ -1.50, -1.50 },
}

for i=1, 2, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_SLAUGHTER" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_SLAUGHTER_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_CATTLEPEN" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

for i=3, 4, 1 do

    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_MILK" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_MILK_NAME", 
        -- Category = "CORE", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_CATTLEPEN" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0.0,
                CameraPitchOffset = 25.0
            },
        },
    })

end

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_SLAUGHTER",
	Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_SLAUGHTER_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_SLAUGHTER1",
			"BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_SLAUGHTER2",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly2a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = poly2b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
            -- { 
            --     Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
            --     Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            -- },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLE_SLAUGHTER",
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
            { Resource = "TOOL", Quantity = 1 },
        }
    },
    DesirabilityModifiers = { {
        Desirability = "DESIRABILITY_RESIDENTIAL",
        Type = "SUBSTRACT",
        Radius = 20.0,
        Value = 0.5
    } },
})

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_MILK",
	Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_MILK_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_MILK3",
			"BUILDING_PART_LIVESTOCKFARM_CATTLEPEN_MILK4",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly2a,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = poly2b,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
            },
            { 
                Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
            -- { 
            --     Polygon = polygon.createRectangle( {4.4, 4.4}, {0.0, 0.0} ),
            --     Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            -- },
        }
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLE_MILK",
    Cost = {
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 5 },
        }
    },
})



-- Job: Herder -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_LIVESTOCKFARM_HERD",
	JobName = "JOB_LIVESTOCKFARM_HERD_NAME",
	JobDescription = "JOB_LIVESTOCKFARM_HERD_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 20.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE",
	},
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_HERD"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_HERD"
    }
})



-- Job: process -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_LIVESTOCKFARM_PROCESS",
	JobName = "JOB_LIVESTOCKFARM_PROCESS_NAME",
	JobDescription = "JOB_LIVESTOCKFARM_PROCESS_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 40.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE",
	},
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_PROCESS"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_PROCESS"
    }
})


-- Building Function: Cattle Yard -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEYARD",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEYARD_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_HERD", 
        Behavior = "BEHAVIOR_WORK"
	},
    InputInventoryCapacity = {
        { Resource = "WATER", Quantity = 50 },
        { Resource = "RESOURCE_HAY", Quantity = 20 },
    },
    ResourceListNeeded = {
        { Resource = "WATER", Quantity = 1 },
        { Resource = "RESOURCE_HAY", Quantity = 1 },
    },
    ResourceProduced = {
        { Resource = "RESOURCE_CATTLE", Quantity = 1 },
        { Resource = "RESOURCE_DUNG", Quantity = 2 },
        }
})



-- Building Function: Cattle -------------------------------------------------------------------------------------
-- mod:register({
--     DataType = "BUILDING_FUNCTION_ASSIGNABLE",
--     Id = "BUILDING_FUNCTION_ASSIGNABLE_LIVESTOCKFARM_CATTLE",
-- 	Name = "BUILDING_FUNCTION_ASSIGNABLE_LIVESTOCKFARM_CATTLE_NAME",
-- 	AuthorizedFunctionList = "FUNCTION_LIST_LIVESTOCKFARM_CATTLE"
-- })

-- mod:register({
--     DataType = "BUILDING_FUNCTION_LIST",
--     Id = "FUNCTION_LIST_LIVESTOCKFARM_CATTLE",
-- 	AssetFunctionList = {
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_MIX_CATTLE",
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_SLAUGHTER_CATTLE",
-- 		"BUILDING_FUNCTION_LIVESTOCKFARM_MILK_CATTLE",
-- 	}
-- })

-- mod:register({
--     DataType = "BUILDING_FUNCTION_WORKPLACE",
--     Id = "BUILDING_FUNCTION_LIVESTOCKFARM_MIX_CATTLE",
--     Name = "BUILDING_FUNCTION_LIVESTOCKFARM_MIX_CATTLE_NAME",
--     WorkerCapacity = 1,
--     RelatedJob = { 
--         Job = "JOB_LIVESTOCKFARM_PROCESS", 
--         Behavior = "BEHAVIOR_WORK"
--     },
--     InputInventoryCapacity = {
-- 		{ Resource = "RESOURCE_CATTLE", Quantity = 2 }
-- 	},
--     ResourceListNeeded = {
-- 		{ Resource = "RESOURCE_CATTLE", Quantity = 2 }
-- 	},
--     ResourceProduced = {
-- 		{ Resource = "BV1_CARCASS", Quantity = 1 },
-- 		{ Resource = "MILK", Quantity = 5 },
-- 	},
-- })

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLE_SLAUGHTER",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLE_SLAUGHTER_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_PROCESS", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
	},
})

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLE_MILK",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLE_MILK_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_PROCESS", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "MILK", Quantity = 3 },
	},
})



-- Spawn cattle in yard and pen -------------------------------------------------------------------------------------
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEYARD1", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 6 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEYARD2", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 6 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEYARD3", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 6 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEYARD4", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 6 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEPEN1", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 1 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEPEN2", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 1 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEPEN3", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 1 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEPEN4", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 1 } )




-- Building Part: Cattle Barn (repupose Dairy Farm) -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_DAIRY_FARM",
    IsHidden = true
})

mod:override({
    Id = "BUILDING_PART_DAIRY_FARM",
    Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEBARN_NAME",
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEBARN",
})



-- Building Part: Pasture -------------------------------------------------------------------------------------
local poly3 = { -- y, x     Facing x in Blender: y increases going left, x increases going down
	{ -5.00, 0.00 },
	{ -2.50, 4.50 },
	{ 2.50, 4.50 },
	{ 5.00, 0.00 },
	{ 2.50, -4.50 },
	{ -2.50, -4.50 },
	{ -5.00, 0.00 },

    { -4.50, 0.00 },
    { -2.00, -4.00 },
    { 2.00, -4.00 },
    { 4.50, 0.00 },
    { 2.00, 4.00 },
	{ -2.00, 4.00 },
	{ -4.50, 0.00 },
}

for i=1, 5, 1 do
    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT" .. i,
        Name = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT" .. i .. "_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_PASTUREPLANT" .. i,
        },
    })
end

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEPASTURE_ASSEMBLAGE",
	Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEPASTURE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_LIVESTOCKFARM_CATTLEPASTURE1" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" }, -- 50
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT2" }, -- 70
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT1" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT3" }, -- 90
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT4" }, -- 110
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" },
			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_PASTUREPLANT5" }, -- 120
		}
	},
	BuildingZone = { 
	},
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 20 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 2 } }
	}
})

mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_CATTLEPASTURE",
	Name = "BUILDING_PART_LIVESTOCKFARM_CATTLEPASTURE_NAME", 
	Description = "BUILDING_PART_LIVESTOCKFARM_CATTLEPASTURE_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
			"BUILDING_PART_LIVESTOCKFARM_CATTLEPASTURE_ASSEMBLAGE",
		},
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { -1, 0, -15 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0
        },
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = poly3,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
    IsMovableWhenBuilt = true,
    AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEPASTURE_RESOURCEGENERATOR_DEFINED",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 20 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 2 } }
	}
})



-- Resource: Pasture -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Pasture.png", "ICON_PASTURE", "ATLAS_CELL")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_PASTURE_CATTLE",
	ResourceName = "RESOURCE_PASTURE_CATTLE_NAME",
	Icon = "ICON_PASTURE",
	ResourceTypeList = { "RESOURCE" },
	IsTradable = false,
	DisplayInInventory = false,
    OrderId = 123,
})



-- Resource Container: Pasture -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Livestock2.fbx/Prefab/CattlePasture.Part.001/PastureContainer.001", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_PASTURE_CATTLE",
    IsReplenishable = true,
    ReplenishDurationInDays = 5,
    ReplenishQuantity = 1,
    ReplenishedMaterial = "MATERIAL_LIVESTOCKFARM_HAY3",
    DepletedMaterial = "MATERIAL_LIVESTOCKFARM_HAY3",
    ResourceValue = 1, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 0.00, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false,
    HasMaximumWorkstation = false
})



-- Building Function: Cattle Pasture -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEBARN",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEBARN_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LIVESTOCKFARM_GATHER", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_PASTURE_CATTLE", Quantity = 1 }, 
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_PASTURE_CATTLE", Quantity = 1 }, 
	},
	ResourceProduced = {
        { Resource = "RESOURCE_CATTLE", Quantity = 1 },
    }
})



-- Building Function: Resource Generator Pasture -------------------------------------------------------------------------------------
-- Not actually used, included so that the user does not see Pastures as decorative in the UI
mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEPASTURE_RESOURCEGENERATOR",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_PASTURE_NAME",
    ResourceGenerated = "RESOURCE_PASTURE_CATTLE",
    IsForConsumer = false,
    IsInfinite = false,
})

mod:register({
    DataType = "BUILDING_FUNCTION_DEFINED_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEPASTURE_RESOURCEGENERATOR_DEFINED",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_PASTURE_NAME",
    ResourceGenerator = "BUILDING_FUNCTION_LIVESTOCKFARM_CATTLEPASTURE_RESOURCEGENERATOR",
    MaxQuantity = 0,
    GrowRate = 0,
})



-- Job: Herder (gatherer) -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_LIVESTOCKFARM_GATHER",
	JobName = "JOB_LIVESTOCKFARM_HERD_NAME",
	JobDescription = "JOB_LIVESTOCKFARM_HERD_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
	UseWorkplaceBehavior = true,
    ProductionDelay = 30, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
        FemaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
        MaleHatList = {
            "PREFAB_LIVESTOCKFARM_HAT",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD",
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_GATHER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LIVESTOCKFARM_GATHER"
    }
})



-- Spawn cattle in pasture -------------------------------------------------------------------------------------
-- mod:registerPrefabComponent("PREFAB_LIVESTOCK_COW", { DataType = "COMP_ENFORCE_RADIUS", Radius = 3 } )
-- mod:registerPrefabComponent("PREFAB_LIVESTOCK_COW", { DataType = "COMP_AGENT", BehaviorTree = "BEHAVIOR_RADIAL_CONFINED_AGENT", RoadPaintSpeed = 0 } )
mod:registerPrefabComponent("PREFAB_LIVESTOCKFARM_CATTLEPASTURE1", { DataType = "COMP_LIVESTOCKFARM", PrefabName = "PREFAB_LIVESTOCK_COW", AnimalCount = 3 } )



-- -- Building Part: Decorative Cow -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_SINGLE",
-- 	Name = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_COWDECORATIVE",
--     },
-- })

-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_ASSEMBLAGE",
-- 	Name = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
-- 		CoreRandomBuildingPartList = { "PREFAB_LIVESTOCK_COW" },
-- 		MandatoryBuildingPartList = {
-- 			{ BuildingPart = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_SINGLE" },
--         },
--     },
-- })

-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE",
-- 	Name = "BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_NAME", 
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
-- 		RandomPartList = {
-- 			"BUILDING_PART_LIVESTOCKFARM_COWDECORATIVE_ASSEMBLAGE",
-- 		},
--         MiniatureConfig = {
--             ClipUnderGround = false,
--             GroupHeight = 0.0,
--             CameraPosition = { 0, 0, 0 },
--             OrientationOffset = 0.0,
--             CameraPitchOffset = 0.0
--         },
--     },
-- })



-- Building Function: Farm Milk Cart (sell directly to villagers) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_LIVESTOCKFARM_MILKCART",
    Name = "BUILDING_FUNCTION_LIVESTOCKFARM_MILKCART_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "LIVESTOCKFARM_RESOURCE_TYPE" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "MILK", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "MILK", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_MILK_SELL", Quantity = 10 },
		-- { Resource = "MILK", Quantity = 10 },
	}
})



-- Building Part: Milk Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_LIVESTOCKFARM_MILKCART",
	Name = "BUILDING_PART_LIVESTOCKFARM_MILKCART_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_LIVESTOCKFARM_MILKCART",
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 20.0
        },
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.5, 1.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_LIVESTOCKFARM_MILKCART",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 1 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 25.0,
		Value = 0.5
	} }
})